% Example-27: COMMON_PRE (Cigarette Smokers' probelm with AOPN)
function [fire, transition] = COMMON_PRE(transition)


global global_info

tname = transition.name;

%%%%%% enabled transition is "tAdmin"   %%%%%%%%%
if strcmpi(tname, 'tAdmin')
    % STEP-1: check each smoker has smoked at least once
    if eq(global_info.SMOKE_COUNTER, 3)
        global_info.STOP_SIMULATION = 1;
        fire = 0;
        return
    end
    
    % step-2: check who is the next smoker, and 
    % hold on to any his resource, so that 
    % the other two resources will be avilable 
    global_info.SMOKE_COUNTER = global_info.SMOKE_COUNTER + 1;
    nextSmoker = global_info.SMOKING_ORDER{global_info.SMOKE_COUNTER};
   
    disp(['Holding  resource ', nextSmoker, '   .....']); 

    if strcmp(nextSmoker, 'tobacco') 
        fire = requestSR({'TO',1}); % hold 'TB'
    elseif strcmp(nextSmoker, 'wrapping_paper') 
        fire = requestSR({'WR',1}); % hold 'WP'
    else % 
        fire = requestSR({'MA',1}); % hold 'WP'
    end
    return
end

%%%%%% enabled transition is a smoker   %%%%%%%%%
% STEP-3: allow the smoker to smoke by acquirng
%         the necessary resources
if strcmpi(tname, 'tTO')
    fire = requestSR({'WR',1, 'MA',1}); 
elseif strcmpi(tname, 'tWR')
    fire = requestSR({'TO',1, 'MA',1}); 
else 
    fire = requestSR({'WR',1, 'TO',1}); 
end
