% Sample code from the book: "Colored Petri Nets for 
% Modeling of Discrete Systems: A practical approach with GPenSIM"
% 
% Example-27: MSF (Cigarette Smokers' probelm with AOPN)
% Reggie.Davidrajuh@uis.no (c) 12 April 2023  
% File: Main Simulation File (msf.m)


clear all; clc; close all;

global global_info
global_info.STOP_AT  = 160; % 
global_info.SMOKING_ORDER = {'tobacco','wrapping_paper','matches'};
global_info.SMOKE_COUNTER = 0; 

pns = pnstruct('csp_AOPN_pdf');

dyn.m0 = {'pAdmin',1};
dyn.ft = {'tAdmin',1, 'tTO',5, 'tWR',15, 'tMA',30}; 
dyn.re = {'TO',1,inf, 'WR',1,inf, 'MA',1,inf}; % resource as semafor

pni = initialdynamics(pns, dyn);

sim = gpensim(pni);
prnschedule(sim);
plotGC(sim);
